/*
             +-----------------------------+                
             |  AList<T>                   |            
             +-----------------------------+                
	         | boolean contains(T that)    | 
             +-----------------------------+                
                         |                    
                        / \                   
                        ---                   
                         |                    
           ---------------------------          
           |                         |          
    +-------------+          +----------------+  
    | MTList      |          | ConsList       |  
    +-------------+          +----------------+  
    +-------------+     +----| T        first | 
                        |    | AList<T> rest  |   
                        |    +----------------+ 
                       / \
               ----          ----
             /                     \
           |                          |
    +------------------+       +-------------+    
    | City             |       | Balloon     |    
    +------------------+       +-------------+    
    | int zip          |       | int    x    |      
    | String name      |       | int    y    |      
    | String state     |       | int radius  |      
    | double longitude |       | Color color |      
    | double latitude  |       +-------------+    
    +------------------+ 
 */  

//to represent a list of objects.
interface AList<T>{
    
  // produce from this list a list of all items 
  // that satisfy the given predicate
  public AList<T> filter(ISelect<T> pick);
}      


