/*
 * @(#)Balloon.java  1.0  30 July 2002
 *
 * @author Viera K. Proulx
 */

import colors.*;

/** A simple class to use for learning about classes and objects. */
public class Balloon {
  
  /*-------------------------------------------------------------------------
   Member data 
   *-----------------------------------------------------------------------*/
  
  /** center of the balloon */
  public int x;
  public int y;
  
  /** the radius of the balloon */
  public int radius;
  
  /** the color of the balloon */
  public AColor c;
  
  /*-------------------------------------------------------------------------
   Constructor
   *-----------------------------------------------------------------------*/
  
  public Balloon (int some_x, int some_y, int some_radius, AColor some_color){
    this.x = some_x;
    this.y = some_y;
    this.radius = some_radius;
    this.c = some_color;
  }
  
  /** copy constructor */
  public Balloon(Balloon someBalloon){
    this.x      = someBalloon.x;
    this.y      = someBalloon.y;
    this.radius = someBalloon.radius;
    this.c      = someBalloon.c;
  }
  
  /** move the balloon by a given distance in both directions */
  Balloon moveBalloon(int dx, int dy){
    
    return new Balloon(this.x + dx, this.y + dy, this.radius, this.c);
  }
  
  /** default constructor */
  public Balloon(){
    this.x      = 200;
    this.y      = 150;
    this.radius = 45;
    this.c      = new Red();
  }
  
  /*-------------------------------------------------------------------------
   Methods 
   *-----------------------------------------------------------------------*/
  
  /** compute the diameter of the balloon */
  int getDiameter(){
    return 2 * this.radius;
  }
  
  /** compute the distance of this balloon from the top of window */
  int distanceFromTop(){
    return this.y - this.radius;
  }
  
  /** compare the top of this and the given other balloon */
  boolean isHigherThan(Balloon otherBln){
    return this.distanceFromTop() < otherBln.distanceFromTop() ;
  }
  
}
