/*
 * @(#)City.java  1.0  22 March 2006
 *
 * @author Viera K. Proulx
 */

import java.text.DecimalFormat;
import java.text.ParseException;
import java.util.NoSuchElementException;
import java.util.StringTokenizer;

import tester.*;

//to get ParseException

/** A simple class to use for learning about classes and objects. */
class City {
  
  /*-------------------------------------------------------------------------
   Member data 
   *-----------------------------------------------------------------------*/
  
  /** The zip code for this city. */
  public int zip;
  
  /** The name of this city. */
  public String name;
  
  /** The state for this city */
  public String state;
  
  /* The longitude for this city */
  public double longitude;
  
  /* The latitude for this city */
  public double latitude;
  
  /* Decimal format to print leading zeros in zip code */
  //private static DecimalFormat zipFormat = new DecimalFormat("00000");
  
  /*-------------------------------------------------------------------------
   Constructor
   *-----------------------------------------------------------------------*/
  
  /* full constructor */
  public City (int zip, String name, String state, 
      double longitude, double latitude){
    this.zip   = zip;
    this.name  = name;
    this.state = state;
    this.longitude = longitude;
    this.latitude  = latitude;
  }    
  /** copy constructor */
  public City(City aCity){
    this(aCity.zip, aCity.name, aCity.state, aCity.longitude, aCity.latitude);
  }
  
  /** the zip code can be given as String */
  public City (String zip, String name, String state, 
      double longitude, double latitude){
    this.zip = this.decimal(zip);
    this.name  = name;
    this.state = state;
    this.longitude = longitude;
    this.latitude  = latitude;
  }
  
  /** default constructor */
  public City(){
    this.zip   = 48170;
    this.name  = "Plymouth";
    this.state = "MI";
    this.longitude  = 83.479946;
    this.latitude = 42.368820;
  }
  
  /** helper method to convert zip code string to integer */
  public int decimal(String s){

    char[] c = s.toCharArray();
    int n = 0;
    for (int i = 0; i < 5; i++){
      if (Character.isDigit(c[i])){
        n = 10 * n + Character.digit(c[i], 10);
      }
      else{
        System.out.println("Converting zip to int failed ");
        System.out.println(c[i] + " is not a digit");
      }
    }
    
    return n;
  }
  
  public static void main(String argv[]){
    City northville = 
      new City(48167, "Northville", "MI", 83.479355, 42.426245);
    City pinckney = 
      new City("48169", "Pinckney", "MI", 83.909918, 42.459579);
    City plymouth = 
      new City(48170, "Plymouth", "MI", 83.479946, 42.36882);
    City northville2 = 
      new City(northville);
    City plymouth2 = new City();
    City lexington = 
      new City(02173, "Lexington", "MA", 71.225916, 42.445384);
    City boston = 
      new City(02115, "Boston", "MA", 71.092215, 42.342706);
    
    System.out.println("Examples of the use of City constructors:");
    System.out.println(Inspector.makeString(northville));
    System.out.println(Inspector.makeString(pinckney));
    System.out.println(Inspector.makeString(plymouth));
    System.out.println(Inspector.makeString(northville2));
    System.out.println(Inspector.makeString(plymouth2));
    System.out.println(Inspector.makeString(lexington));
    System.out.println(Inspector.makeString(boston));
    
   
    // more tests needed ...
  }
  
}
