import java.util.*;
import colors.*;
import draw.*;
import geometry.*;
import tester.*;

/**
 * The client class for the parametrized list classes and examples of
 * parametrized lists of Balloon and City objects
 * 
 * @author Viera K. Proulx  and ... student1 ... student 2
 * @since November 3, 2007
 */
public class Examples implements Testable{
  
  public Examples(){}
  
  public Balloon b1 = new Balloon(100, 200, 25, new Red());
  public Balloon b2 = new Balloon(200, 100, 25, new Blue());
  
  City northville = 
    new City(48167, "Northville", "MI", 83.479355, 42.426245);
  City pinckney = 
    new City("48169", "Pinckney", "MI", 83.909918, 42.459579);
  City plymouth = 
    new City(48170, "Plymouth", "MI", 83.479946, 42.36882);
  City northville2 = 
    new City(northville);
  City plymouth2 = new City();
  City lexington = 
    new City(02173, "Lexington", "MA", 71.225916, 42.445384);
  City boston = 
    new City(02115, "Boston", "MA", 71.092215, 42.342706);
  
 
  /**
   * The collection of tests to be done
   * 
   * @param t
   */  
  public void testMethods(Tester t){      	
    
    // Your examples and tests go here.
    
    // Balloon class tests: equality
    t.test("the same balloons OK", b2, 
        new Balloon(200, 100, 25, new Blue()));
    t.test("the same balloons OK", b2, b2);
    t.test("not the same balloons fail", b2, b1); 	
       
    // test the getDiameter method in the class Balloon
    t.test("getDiameter", 50, b2.getDiameter());
    
    // test the moveBalloon method in the class Balloon
    t.test("moveBalloon", new Balloon(150, 150, 25, new Red()),
        b1.moveBalloon(50, -50));   
    
    // test the distanceFromTop method in the class Balloon
    t.test("distanceFromTop", 200 - 25, b1.distanceFromTop());    
    
    // test the isHigherThan method in the class Balloon
    t.test("isHigherThan", false, b1.isHigherThan(b2));   
  }
  
  /**
   * Run all tests
   * 
   * @param t the <CODE>{@link Tester Tester}</CODE> that performs the tests
   */
  public void tests(Tester t){
    testMethods(t);
  }
  
  // ------------ generate the test reports --------------------------------
  // add at the end of the Examples class
  public void go(){
    Tester tester = new Tester();
    tester.runTests(this);

    System.out.println("Invoking t.testReport: \n");      
    tester.testReport();

    System.out.println("---------------------------------------------------");
    System.out.println("Invoking t.fullTestReport: \n");
    tester.fullTestReport();
  }
  
  // run all tests given by the Examples class
  public static void main(String[] argv){
    Examples e = new Examples();
    
    Reflector r = new Reflector(e.b1);
    r.printInfo();
    System.out.println(Inspector.makeString(e));
    
    e.go();
  }
  
}